Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security
Class KeyPairGenerator

    java.lang.Object
      java.security.KeyPairGeneratorSpi
          java.security.KeyPairGenerator

    public abstract class KeyPairGenerator

extends KeyPairGeneratorSpi

The KeyPairGenerator class is used to generate pairs of public and private keys. Key pair generators are constructed using the `getInstance` factory methods (static methods that return instances of a given class).

A Key pair generator for a particular algorithm creates a public/private key pair that can be used with this algorithm. It also associates algorithm-specific parameters with each of the generated keys.

There are two ways to generate a key pair: in an algorithm-independent manner, and in an algorithm-specific manner. The only difference between the two is the initialization of the object:

- Algorithm-Independent Initialization

  All key pair generators share the concepts of a keysize and a source of randomness. The keysize is interpreted differently for different algorithms (e.g., in the case of the DSA algorithm, the keysize corresponds to the length of the modulus). There is an `initialize` method in this KeyPairGenerator class that takes these two universally shared types of arguments. There is also one that takes just a `keysize` argument, and uses the `SecureRandom` implementation of the highest-priority installed provider as the source of randomness. (If none of the installed providers supply an implementation of `SecureRandom`, a system-provided source of randomness is used.)

  Since no other parameters are specified when you call the above algorithm-independent `initialize` methods, it is up to the provider what to do about the algorithm-specific parameters (if any) to be associated with each of the keys.

  If the algorithm is the DSA algorithm, and the keysize (modulus size) is 512, 768, or 1024, then the Sun provider uses a set of precomputed values for the `p`, `q`, and `g` parameters. If the modulus size is not one of the above values, the Sun provider creates a new set of parameters. Other providers might have precomputed parameter sets for more than just the three modulus sizes mentioned above. Still others might not have a list of precomputed parameters at all and instead always create new parameter sets.

- Algorithm-Specific Initialization

  For situations where a set of algorithm-specific parameters already exists (e.g., so-called community parameters in DSA), there are two `initialize` methods that have an `AlgorithmParameterSpec` argument. One also has a `SecureRandom` argument, while the the other uses the `SecureRandom` implementation of the highest-priority installed provider as the source of randomness. (If none of the installed providers supply an implementation of `SecureRandom`, a system-provided source of randomness is used.)

In case the client does not explicitly initialize the KeyPairGenerator (via a call to an `initialize` method), each provider must supply (and document) a default initialization. For example, the Sun provider uses a default modulus size (keysize) of 1024 bits.

Note that this class is abstract and extends from `KeyPairGeneratorSpi` for historical reasons. Application developers should only take notice of the methods defined in this `KeyPairGenerator` class; all the methods in the superclass are intended for cryptographic service providers who wish to supply their own implementations of key pair generators.

See Also:
  `AlgorithmParameterSpec`

Constructor Summary
`protected` | `KeyPairGenerator(String algorithm)` Creates a KeyPairGenerator object for the specified algorithm.

Method Summary
`KeyPair` | `generateKeyPair()` Generates a key pair.
`KeyPair` | `genKeyPair()` Generates a key pair.
`String` | `getAlgorithm()` Returns the standard name of the algorithm for this key pair generator.
`static KeyPairGenerator` | `getInstance(String algorithm)` Returns a KeyPairGenerator object that generates public/private key pairs for the specified algorithm.
`static KeyPairGenerator` | `getInstance(String algorithm, Provider provider)` Returns a KeyPairGenerator object that generates public/private key pairs for the specified algorithm.
`static KeyPairGenerator` | `getInstance(String algorithm, String provider)` Returns a KeyPairGenerator object that generates public/private key pairs for the specified algorithm.
`Provider` | `getProvider()` Returns the provider of this key pair generator object.
`void` | `initialize(AlgorithmParameterSpec params)` Initializes the key pair generator using the specified parameter set and the `SecureRandom` implementation of the highest-priority installed provider as the source of randomness.
`void` | `initialize(AlgorithmParameterSpec params, SecureRandom random)` Initializes the key pair generator with the given parameter set and source of randomness.
`void` | `initialize(int keysize)` Initializes the key pair generator for a certain keysize using a default parameter set and the `SecureRandom` implementation of the highest-priority installed provider as the source of randomness.
`void` | `initialize(int keysize, SecureRandom random)` Initializes the key pair generator for a certain keysize with the given source of randomness (and a default parameter set).

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### KeyPairGenerator

    protected KeyPairGenerator(String algorithm)

  Creates a KeyPairGenerator object for the specified algorithm.

  Parameters:
    `algorithm` - the standard string name of the algorithm. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.

Method Detail

### getAlgorithm

    public String getAlgorithm()

  Returns the standard name of the algorithm for this key pair generator. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.

  Returns:
    the standard string name of the algorithm.

### getInstance

    public static KeyPairGenerator getInstance(String algorithm)
                                        throws NoSuchAlgorithmException

  Returns a KeyPairGenerator object that generates public/private key pairs for the specified algorithm.

  This method traverses the list of registered security Providers, starting with the most preferred Provider. A new KeyPairGenerator object encapsulating the KeyPairGeneratorSpi implementation from the first Provider that supports the specified algorithm is returned.

  Note that the list of registered providers may be retrieved via the `Security.getProviders()` method.

  Parameters:
    `algorithm` - the standard string name of the algorithm. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
  Returns:
    the new KeyPairGenerator object.
  Throws:
    `NoSuchAlgorithmException` - if no Provider supports a KeyPairGeneratorSpi implementation for the specified algorithm.
  See Also:
    `Provider`

### getInstance

    public static KeyPairGenerator getInstance(String algorithm,
                                               String provider)
                                        throws NoSuchAlgorithmException,
                                               NoSuchProviderException

  Returns a KeyPairGenerator object that generates public/private key pairs for the specified algorithm.

  A new KeyPairGenerator object encapsulating the KeyPairGeneratorSpi implementation from the specified provider is returned. The specified provider must be registered in the security provider list.

  Note that the list of registered providers may be retrieved via the `Security.getProviders()` method.

  Parameters:
    `algorithm` - the standard string name of the algorithm. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
    `provider` - the string name of the provider.
  Returns:
    the new KeyPairGenerator object.
  Throws:
    `NoSuchAlgorithmException` - if a KeyPairGeneratorSpi implementation for the specified algorithm is not available from the specified provider.
    `NoSuchProviderException` - if the specified provider is not registered in the security provider list.
    `IllegalArgumentException` - if the provider name is null or empty.
  See Also:
    `Provider`

### getInstance

    public static KeyPairGenerator getInstance(String algorithm,
                                               Provider provider)
                                        throws NoSuchAlgorithmException

  Returns a KeyPairGenerator object that generates public/private key pairs for the specified algorithm.

  A new KeyPairGenerator object encapsulating the KeyPairGeneratorSpi implementation from the specified Provider object is returned. Note that the specified Provider object does not have to be registered in the provider list.

  Parameters:
    `algorithm` - the standard string name of the algorithm. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
    `provider` - the provider.
  Returns:
    the new KeyPairGenerator object.
  Throws:
    `NoSuchAlgorithmException` - if a KeyPairGeneratorSpi implementation for the specified algorithm is not available from the specified Provider object.
    `IllegalArgumentException` - if the specified provider is null.
  Since:
    1.4
  See Also:
    `Provider`

### getProvider

    public final Provider getProvider()

  Returns the provider of this key pair generator object.

  Returns:
    the provider of this key pair generator object

### initialize

    public void initialize(int keysize)

  Initializes the key pair generator for a certain keysize using a default parameter set and the `SecureRandom` implementation of the highest-priority installed provider as the source of randomness. (If none of the installed providers supply an implementation of `SecureRandom`, a system-provided source of randomness is used.)

  Parameters:
    `keysize` - the keysize. This is an algorithm-specific metric, such as modulus length, specified in number of bits.
  Throws:
    `InvalidParameterException` - if the `keysize` is not supported by this KeyPairGenerator object.

### initialize

    public void initialize(int keysize,
                           SecureRandom random)

  Initializes the key pair generator for a certain keysize with the given source of randomness (and a default parameter set).

  Specified by:
    `initialize` in class `KeyPairGeneratorSpi`
  Parameters:
    `keysize` - the keysize. This is an algorithm-specific metric, such as modulus length, specified in number of bits.
    `random` - the source of randomness.
  Throws:
    `InvalidParameterException` - if the `keysize` is not supported by this KeyPairGenerator object.
  Since:
    1.2

### initialize

    public void initialize(AlgorithmParameterSpec params)
                    throws InvalidAlgorithmParameterException

  Initializes the key pair generator using the specified parameter set and the `SecureRandom` implementation of the highest-priority installed provider as the source of randomness. (If none of the installed providers supply an implementation of `SecureRandom`, a system-provided source of randomness is used.).

  This concrete method has been added to this previously-defined abstract class. This method calls the KeyPairGeneratorSpi `initialize` method, passing it `params` and a source of randomness (obtained from the highest-priority installed provider or system-provided if none of the installed providers supply one). That `initialize` method always throws an UnsupportedOperationException if it is not overridden by the provider.

  Parameters:
    `params` - the parameter set used to generate the keys.
  Throws:
    `InvalidAlgorithmParameterException` - if the given parameters are inappropriate for this key pair generator.
  Since:
    1.2

### initialize

    public void initialize(AlgorithmParameterSpec params,
                           SecureRandom random)
                    throws InvalidAlgorithmParameterException

  Initializes the key pair generator with the given parameter set and source of randomness.

  This concrete method has been added to this previously-defined abstract class. This method calls the KeyPairGeneratorSpi `initialize` method, passing it `params` and `random`. That `initialize` method always throws an UnsupportedOperationException if it is not overridden by the provider.

  Overrides:
    `initialize` in class `KeyPairGeneratorSpi`
  Parameters:
    `params` - the parameter set used to generate the keys.
    `random` - the source of randomness.
  Throws:
    `InvalidAlgorithmParameterException` - if the given parameters are inappropriate for this key pair generator.
  Since:
    1.2

### genKeyPair

    public final KeyPair genKeyPair()

  Generates a key pair.

  If this KeyPairGenerator has not been initialized explicitly, provider-specific defaults will be used for the size and other (algorithm-specific) values of the generated keys.

  This will generate a new key pair every time it is called.

  This method is functionally equivalent to `generateKeyPair`.

  Returns:
    the generated key pair
  Since:
    1.2

### generateKeyPair

    public KeyPair generateKeyPair()

  Generates a key pair.

  If this KeyPairGenerator has not been initialized explicitly, provider-specific defaults will be used for the size and other (algorithm-specific) values of the generated keys.

  This will generate a new key pair every time it is called.

  This method is functionally equivalent to `genKeyPair`.

  Specified by:
    `generateKeyPair` in class `KeyPairGeneratorSpi`
  Returns:
    the generated key pair

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2008 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.